<?php

namespace AppBundle\Repository\Time;

use AppBundle\Entity\Time\Xvent;
use AppBundle\Object\EventSearch;

/**
 * XventRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class XventRepository extends \Doctrine\ORM\EntityRepository
{

    private function queryLastPublic()
    {
        $now = new \DateTime();
        $now->setTime(0, 0, 0);
        $qb = $this->createQueryBuilder('x')
            ->innerJoin('x.referedGroups', 'g');
        $qb->addOrderBy('x.date', 'DESC')
                ->andWhere("x.date < :now")
                ->setParameter("now", $now)
        ->andWhere("g.weight = :weight")
        ->setParameter("weight", 0);
        $qb->setMaxResults(1);
        $events = $qb->getQuery()->getResult();

        if(count($events) > 0)
            return $events['0'];
        return null;
    }

    public function queryAllEvents($public = false, $which = 'all', EventSearch $filters = null)
    {
        $asc = false;
        $qb = $this->createQueryBuilder('x');

        if($public) {
            $qb->where('x.public = :public')
                ->setParameter("public", $public);
        }

        switch($which)  {
            case 'future':
            $asc = true;
            $now = new \DateTime();
            $now->setTime(0, 0, 0);
            $qb ->andWhere("x.date IS NULL OR x.date >= :now")
                ->setParameter("now", $now);
            break;
            case 'past':
                $now = new \DateTime();
                $qb ->andWhere("x.date IS NOT NULL AND x.date < :now")
                    ->setParameter("now", $now);
                break;
            default:
            case 'all':
                break;

        }
        if($filters and $filters->getLabel()){
            $qb->andWhere('x.title like :label or x.description like :label')
                ->setParameter('label', '%'.$filters->getLabel().'%');
        }

        if ($filters and $filters->getGroup()){
            $qb->innerJoin('x.referedGroups', 'g'); // Inner Join with users
            $qb->where('g.id = :group')
                ->setParameter('group', $filters->getGroup());
        }
        if ($filters and $filters->getDateBefore()) {
            $qb->andWhere('x.date < :dateBefore')
                ->setParameter('dateBefore', $filters->getDateBefore());
        }
        if ($filters and $filters->getDateAfter()) {
            $qb->andWhere('x.date > :dateAfter')
                ->setParameter('dateAfter', $filters->getDateAfter());
        }
        if ($filters and $filters->getDateOrder()) {
            $qb->orderBy('x.date', $filters->getDateOrder());
        } else {
            $qb->orderBy('x.date', $asc ? 'ASC' : 'DESC');
        }

        return $qb;
    }

    /* used on dashboard calendar */
    public function queryDashboardEvents()
    {
        $qb = $this->queryAllEvents(false, 'future');
        $last = $this->queryLastPublic();
        if($last) {
            $qb->orWhere("x.id = :last")
                ->setParameter("last", $last->getId());
        }
        return $qb;
    }

    /* used on task timeline */
    public function queryNextActionEvent($n)
    {
        $qb = $this->createQueryBuilder('x');

        $qb->orderBy('x.date', 'DESC');

        $qb->setMaxResults($n);
        $res = $qb->getQuery()->getResult();
        if(count($res) > $n - 1)
            return $res[$n - 1];
        return null;
    }

    /* used on dashboard timeline */
    public function queryLastEvents($limit = null, $recent = false)
    {
        $qb = $this->createQueryBuilder('e')
            ->orderBy('e.createdAt', 'DESC');
        if($limit) {
                $qb->setMaxResults($limit);
        }
        if($recent) {
            $date = new \DateTime();
            $date->sub(new \DateInterval("P3M")); // check info sooner than 3 month
            $qb->where('e.createdAt > :date')
                ->setParameter('date', $date);
        }

        return $qb;
    }

    public function findEvents(EventSearch $filters)
    {
        $which = Xvent::TIMELINE_ALL;
        if($filters and $filters->getTimeline()) {
            $which = $filters->getTimeline();
        }
        return $this->queryAllEvents(false, $which, $filters);
    }
}
